
object List {

  def empty[T] ():List[T] = new ListEmpty[T]()

  def cons[T] (n:T, L:List[T]):List[T] = new ListCons[T](n,L)


  // EMPTY LIST REPRESENTATION
  //
  private class ListEmpty[T] () extends List[T] {
    def isEmpty ():Boolean = true
    def first ():T = 
      throw new RuntimeException("empty().first()")
    def rest ():List[T] = 
      throw new RuntimeException("empty().rest()")
    def length ():Int = 0

//    def update (v:T):Unit = 
//      throw new RuntimeException("empty().update()")

//    def find (f:T):Boolean = false

//    def find[U>:T] (f:U):Boolean = false

    def toStringLst ():String = "]"
    override def toString ():String = ""
  }


  // CONS LIST REPRESENTATION
  //
  private class ListCons[T] (n:T, L:List[T]) extends List[T] {

    private var node:T = n

    def isEmpty ():Boolean = false
    def first ():T = node
    def rest ():List[T] = L
    def length ():Int = 1 + L.length()

//    def update (v:T):Unit = (node = v)
      
//    def find (f:T):Boolean = { (f == node) || L.find(f) }

//    def find[U >: T] (f:U):Boolean = { (f == node) || L.find(f) }

    def toStringLst ():String = "," + node + L.toStringLst()
    override def toString ():String = "[" + node + L.toStringLst()
  }
}


abstract class List[+T] {    // T for invariant; +T for covariant

  def isEmpty ():Boolean
  def first ():T
  def rest (): List[T]
  def length ():Int

//  def update (v:T):Unit 

//  def find (f:T):Boolean

//  def find[U >: T] (f:U):Boolean

  protected def toStringLst ():String
}
